using System;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using System.Collections;
using System.Text;

namespace YAPS
{
    public class Settings
    {
        private String RecordingsFilename;
        private String DoneRecordingsFilename;
        private VCRScheduler internal_vcr_scheduler;
        private HttpServer internal_http_server;

        public Settings(String RFilename, String DRFilename,VCRScheduler vcrScheduler, HttpServer webserver)
        {
            RecordingsFilename = RFilename;
            DoneRecordingsFilename = DRFilename;
            internal_http_server = webserver;
            internal_vcr_scheduler = vcrScheduler;
        }

        #region SaveSettings
        /// <summary>
        /// this method saves the settings to the actual config file
        /// </summary>
        public void SaveSettings()
        {
            FileStream fs;
            // TODO: make it thread safe

            #region Recordings
            ConsoleOutputLogger.WriteLine("Saving Recordings...");
            fs = new FileStream (RecordingsFilename,FileMode.OpenOrCreate ,FileAccess.Write );
            try
            {
                BinaryFormatter bf=new BinaryFormatter ();
                bf.Serialize(fs, internal_vcr_scheduler.Recordings);
            }
            finally
            {
                fs.Close ();
            }
            #endregion

            #region DoneRecordings
            ConsoleOutputLogger.WriteLine("Saving DoneRecordings...");
            fs = new FileStream(DoneRecordingsFilename, FileMode.OpenOrCreate, FileAccess.Write);
            try
            {
                BinaryFormatter bf = new BinaryFormatter();
                bf.Serialize(fs, internal_vcr_scheduler.doneRecordings);
            }
            finally
            {
                fs.Close();
            }
            #endregion

            #region Channel-Number-Name-Mapping

            #endregion
        }
        #endregion

        #region LoadSettings
        /// <summary>
        /// guess what it does...it Loads the Settings from the Config File; it's usually only called at startup time
        /// </summary>
        public void LoadSettings()
        {
            // TODO: Error checking; what happens when the config files are corrupt?

            FileStream fs;
            #region Recordings
            if (File.Exists(RecordingsFilename))
            {
                ConsoleOutputLogger.WriteLine("Loading Recordings...");
                fs = new FileStream(RecordingsFilename, FileMode.Open, FileAccess.Read);
                try
                {
                    BinaryFormatter bf = new BinaryFormatter();
                    internal_vcr_scheduler.Recordings = (Hashtable)bf.Deserialize(fs);
                }
                finally
                {
                    fs.Close();
                }
            }
            else
                ConsoleOutputLogger.WriteLine("No Recordings Configfile found.");
            #endregion

            #region DoneRecordings
            if (File.Exists(DoneRecordingsFilename))
            {
                ConsoleOutputLogger.WriteLine("Loading DoneRecordings...");
                fs = new FileStream(DoneRecordingsFilename, FileMode.Open, FileAccess.Read);
                try
                {
                    BinaryFormatter bf = new BinaryFormatter();
                    internal_vcr_scheduler.doneRecordings = (Hashtable)bf.Deserialize(fs);
                }
                finally
                {
                    fs.Close();
                }
            }
            else
                ConsoleOutputLogger.WriteLine("No DoneRecordings Configfile found.");
            #endregion

        }
        #endregion
    }
}